#ifndef DRV8835MotorShield_h
#define DRV8835MotorShield_h

#if defined(__AVR_ATmega168__) || defined(__AVR_ATmega328P__) || defined (__AVR_ATmega32U4__)
  #define DRV8835MOTORSHIELD_USE_20KHZ_PWM
#endif

#include <Arduino.h>

#define M_FORWARD  	 1
#define M_BACKWARD 	-1

#define M_RIGHT		 1
#define M_LEFT		-1

#define M_MOTORR	 1
#define M_MOTORL	-1

#define ONE_STEP 	1
#define TWO_STEP 	2
#define THREE_STEP 	3
#define FOUR_STEP 	4
#define FIVE_STEP 	5

#define SPEED_LOW	30
#define SPEED_MID	60
#define SPEED_FAST	90

class DRV8835MotorShield
{
  public:
    static void setM1Speed(int speed);
    static void setM2Speed(int speed);
    static void setSpeeds(int m1Speed, int m2Speed);
    static void flipM1(boolean flip);
    static void flipM2(boolean flip);
	static void motorRun(int dir, int distance, int speed);
	static void motorRun(int dir, int speed);
	static void motorRot(int rotate, int speed);
	static void moveMotor(int motor, int speed);
	static void motorStop();
	
  private:
    static void initPinsAndMaybeTimer();
    static const unsigned char _M1DIR;
    static const unsigned char _M2DIR;
    static const unsigned char _M1PWM;
    static const unsigned char _M2PWM;
    static boolean _flipM1;
    static boolean _flipM2;
    
    static inline void init()
    {
      static boolean initialized = false;

      if (!initialized)
      {
        initialized = true;
        initPinsAndMaybeTimer();
      }
    }
};
#endif