#include "HC_SR04.h"

HC_SR04 *HC_SR04::_instance(NULL);

HC_SR04::HC_SR04(int trigger, int echo, int max_dist)
    : _trigger(trigger), _echo(echo),_max(max_dist), _finished(false)
{
  if(_instance==0) _instance=this;    
}

void HC_SR04::begin(){
  pinMode(_trigger, OUTPUT);
  digitalWrite(_trigger, LOW);
  pinMode(_echo, INPUT);  
  if(digitalPinToInterrupt(_echo)>=0){		
	  attachInterrupt(digitalPinToInterrupt(_echo), _echo_isr, CHANGE);
  }

  start();
}

void HC_SR04::start(){
  _finished=false;
  digitalWrite(_trigger, HIGH);
  delayMicroseconds(10);
  digitalWrite(_trigger, LOW);  
}

unsigned int HC_SR04::getRange(){		//unit: cm
  return (_end-_start)/58;
}

unsigned int HC_SR04::getDistance(){
	int distance;
	if(digitalPinToInterrupt(_echo)>=0)
	{
		if(isFinished()){
			distance = getRange();
			start();
		}
		delay(10);
	}
	else{
		distance = pulseIn(_echo,HIGH,30000)/58;
	}
	return distance;	
}

void HC_SR04::_echo_isr(){
  HC_SR04* _this=HC_SR04::instance();
  
  switch(digitalRead(_this->_echo)){
    case HIGH:
      _this->_start=micros();
      break;
    case LOW:
      _this->_end=micros();
      _this->_finished=true;
      break;
  }   
}
